#include "predef.h" 
#include <stdio.h>
#include <ctype.h>
#include <startnet.h>
#include <autoupdate.h>
#include <dhcpclient.h>
#include <sim5234.h>



extern "C" { 
void UserMain(void * pd);
extern const unsigned long CPU_CLOCK;
}

const char * AppName="bare_serial";



void OpenBareSerial(int port, unsigned long baud)
{

volatile uartstruct *ThisUart = &sim.uarts[port];

unsigned char ub1 = 0;
unsigned char ub2 = 0x41;

/* Calculate baud rate */
DWORD hdiv = ( ( ( CPU_CLOCK / 32 ) / baud ) + 1 ) >> 1;
ub1 = ( hdiv >> 8 ) & 0xFF;
ub2 = ( hdiv & 0xFF );

ThisUart->ucr = 0x2a; /*Reset Rx Transmit disable Rx disable */
ThisUart->ucr = 0x3a;    /*Reset Tx Transmit disable Rx disable */
ThisUart->ucr = 0x1a;/*Transmit disable Rx disable reset mode reg */

ThisUart->ucr = 0x10;
ThisUart->umr = 0x13; /* umr1 8 data bits no parity */
ThisUart->umr = 0x27;  /* umr2 1 stop*/ 

ThisUart->usr = 0xDD; /* Use the internal timer for Baud Rate Generation */
ThisUart->uipcr= 0x00; 
ThisUart->uisr = 0x00;  /*Enable No interrupts */

ThisUart->dur = ub1; /* Actualy set the baud rate we calculated */
ThisUart->dlr = ub2;


switch (port) /* Set up the hardware ports */
{
case 0:
	sim.gpio.par_uart |= 0x000F;   // MCF5235 RM 12.3.1.5.7
    break;
case 1:
	sim.gpio.par_uart |= 0x0FF0;   // MCF5235 RM 12.3.1.5.7
	break;
case 2:
	sim.gpio.par_uart |= 0x3000;   // MCF5235 RM 12.3.1.5.7
	break;
}//End of switch


ThisUart->ucr = 0x05;/*Enable Tx and Rx */ 
}


void NoIsrWriteChar(int port, char c)
{
 while ( ( sim.uarts[port].usr & 4 ) == 0 ); 
 sim.uarts[port].utb = ( unsigned char ) c;  
}


char NoIsrGetChar(int port)
{
while ( ( sim.uarts[port].usr & 1 ) == 0 );
return sim.uarts[port].utb;
}


int NoIsrCharAvail(int port)
{
   return  ( ( sim.uarts[port].usr & 1 ) != 0 );
}








void UserMain(void * pd)
{
   InitializeStack();
   if (EthernetIP == 0) GetDHCPAddress(); 
   OSChangePrio(MAIN_PRIO);
   EnableAutoUpdate();

   OpenBareSerial(1,115200);

   iprintf("Application started\n");
   while (1)
  {
	   char c=NoIsrGetChar(1);
	   NoIsrWriteChar(1,c);

  }
}
